# coding: utf-8

"""
    Aliro Q.Network

    This is an api for the Aliro Q.Network  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: nick@aliroquantum.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from aliro_quantum_networking.configuration import Configuration


class ErrorModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'error_model_name': 'str',
        'probability': 'float'
    }

    attribute_map = {
        'error_model_name': 'errorModelName',
        'probability': 'probability'
    }

    def __init__(self, error_model_name=None, probability=0, local_vars_configuration=None):  # noqa: E501
        """ErrorModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._error_model_name = None
        self._probability = None
        self.discriminator = None

        self.error_model_name = error_model_name
        if probability is not None:
            self.probability = probability

    @property
    def error_model_name(self):
        """Gets the error_model_name of this ErrorModel.  # noqa: E501


        :return: The error_model_name of this ErrorModel.  # noqa: E501
        :rtype: str
        """
        return self._error_model_name

    @error_model_name.setter
    def error_model_name(self, error_model_name):
        """Sets the error_model_name of this ErrorModel.


        :param error_model_name: The error_model_name of this ErrorModel.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and error_model_name is None:  # noqa: E501
            raise ValueError("Invalid value for `error_model_name`, must not be `None`")  # noqa: E501
        allowed_values = ["bitflip", "depolarizing", "dephasing"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and error_model_name not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `error_model_name` ({0}), must be one of {1}"  # noqa: E501
                .format(error_model_name, allowed_values)
            )

        self._error_model_name = error_model_name

    @property
    def probability(self):
        """Gets the probability of this ErrorModel.  # noqa: E501


        :return: The probability of this ErrorModel.  # noqa: E501
        :rtype: float
        """
        return self._probability

    @probability.setter
    def probability(self, probability):
        """Sets the probability of this ErrorModel.


        :param probability: The probability of this ErrorModel.  # noqa: E501
        :type: float
        """
        if (self.local_vars_configuration.client_side_validation and
                probability is not None and probability > 1):  # noqa: E501
            raise ValueError("Invalid value for `probability`, must be a value less than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                probability is not None and probability < 0):  # noqa: E501
            raise ValueError("Invalid value for `probability`, must be a value greater than or equal to `0`")  # noqa: E501

        self._probability = probability

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ErrorModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ErrorModel):
            return True

        return self.to_dict() != other.to_dict()
